'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _WatchmanConnector = require('./WatchmanConnector');

var _WatchmanConnector2 = _interopRequireDefault(_WatchmanConnector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debug = (0, _debug2.default)('watchman:filesystem');

var WatchmanWatchFileSystem = function () {
  function WatchmanWatchFileSystem(inputFileSystem, options) {
    _classCallCheck(this, WatchmanWatchFileSystem);

    this.inputFileSystem = inputFileSystem;
    this.options = options;
  }

  _createClass(WatchmanWatchFileSystem, [{
    key: 'watch',
    value: function watch(files, dirs, missing, startTime, options, callback, callbackUndelayed) {
      var _this = this;

      if (!Array.isArray(files)) throw new Error("Invalid arguments: 'files'");
      if (!Array.isArray(dirs)) throw new Error("Invalid arguments: 'dirs'");
      if (!Array.isArray(missing)) throw new Error("Invalid arguments: 'missing'");
      if (typeof callback !== 'function') throw new Error("Invalid arguments: 'callback'");
      if (typeof startTime !== 'number' && startTime) throw new Error("Invalid arguments: 'startTime'");
      if (typeof options !== 'object') throw new Error("Invalid arguments: 'options'");
      if (typeof callbackUndelayed !== 'function' && callbackUndelayed) throw new Error("Invalid arguments: 'callbackUndelayed'");
      var oldWatcher = this.watcher;

      debug('creating new connector');
      var watcher = new _WatchmanConnector2.default(Object.assign({}, options, this.options));
      this.watcher = watcher;

      if (callbackUndelayed) {
        watcher.once('change', function (filePath, mtime) {
          debug('change event received for %s with mtime', filePath, mtime);
          callbackUndelayed(filePath, mtime);
        });
      }

      watcher.once('aggregated', function (changes, removals, clock) {
        _this.lastClock = clock;
        var allChanges = changes.concat(removals);
        debug('aggregated event received with changes: ', changes);
        if (_this.inputFileSystem && _this.inputFileSystem.purge) {
          _this.inputFileSystem.purge(allChanges);
        }

        var times = watcher.getTimes();

        callback(null, changes.filter(function (file) {
          return files.indexOf(file) >= 0;
        }).sort(), changes.filter(function (file) {
          return dirs.indexOf(file) >= 0;
        }).sort(), changes.filter(function (file) {
          return missing.indexOf(file) >= 0;
        }).sort(), times, times);
      });

      watcher.watch(files.concat(missing), dirs, this.lastClock || startTime);

      if (oldWatcher) {
        debug('closing old connector');
        oldWatcher.close();
      }

      return {
        close: function close() {
          if (_this.watcher) {
            _this.watcher.close();
            _this.watcher = null;
          }
        },
        pause: function pause() {
          if (_this.watcher) _this.watcher.pause();
        }
      };
    }
  }]);

  return WatchmanWatchFileSystem;
}();

exports.default = WatchmanWatchFileSystem;